#include <stdio.h>
#include "pgmlib.h"
#include <math.h>
#include "fft.h"

#define PI 3.14159265


void make_original_image(int n);
void make_original_data(int n);
void add_sin_waves(int n, double a0, double a, double Nx, double theta_x, double Ny, double theta_y);
void save_spectrum(int n);


int main() {


	char file[256] = "";
	make_original_image(0);
	make_original_data(0);
	save_image(0, file);
	FFT2(1);
	
	save_spectrum(1);
	save_image(1,file);
	return 0;
}

void make_original_data(int n)
/* 摜No.ñf[^ data[x][y], jdata[x][y] ɑ */
{
	int i, j;

	if (width[n] != height[n]) {
		printf("cƉ̉fقȂĂ̂ŏI܂D\n");
		exit(1);
	}
	else {
		printf("\nǂݍ񂾉摜f[^ɂ܂D\n");
		num_of_data = width[n];
		for (j = 0; j < num_of_data; j++) {
			for (i = 0; i < num_of_data; i++) {
				data[i][j] = (double)image[n][i][j];
				jdata[i][j] = 0.0;  /* 0 */
			}
		}
	}
}


void save_spectrum(int n)
/* UXyNgt@CƂďo͂ */
{
	char file_name[256]; /* t@Cp̕z */
	FILE* fp;            /* t@C|C^ */
	double power_spectrum[256][256];
	double min_val, max_val;

	int i, j, x, y;         /* [vϐ */
	int num2;

	/* o̓t@C̃I[v */
	printf("XyNgf[^̏o̓t@C(*.csv) : ");
	scanf("%s", file_name);
	fp = fopen(file_name, "w"); /* AXL[[h */
	/* re^2+im^2o */
	num2 = num_of_data / 2;
	for (j = 0; j < num_of_data; j++) {
		if (j < num2) y = j + num2;
		else          y = j - num2;
		for (i = 0; i < num_of_data; i++) {
			if (i < num2) x = i + num2;
			else          x = i - num2;
			power_spectrum[i][j] = pow(data[x][y], 2) + pow(jdata[x][y], 2);
			fprintf(fp, "%f", power_spectrum[i][j]);
			if (i != num_of_data - 1) fprintf(fp, ",");
			else fprintf(fp, "\n");
		}
	}
	fclose(fp);

	width[n] = num_of_data;
	height[n] = num_of_data;

	min_val = power_spectrum[0][0];	max_val = power_spectrum[0][0];
	for (j = 0; j < num_of_data; j++) {
		for (i = 0; i < num_of_data; i++) {
			if (min_val > power_spectrum[i][j]) min_val = power_spectrum[i][j];
			if (max_val < power_spectrum[i][j]) max_val = power_spectrum[i][j];
		}
	}

	for (j = 0; j < num_of_data; j++) {
		for (i = 0; i < num_of_data; i++) {
			image[n][i][j] = (power_spectrum[i][j] - min_val) / (max_val - min_val)*255.0;
			if (image[n][i][j] == 255)
				printf("stop");

		}
	}
	



}


void make_original_image(int n) {


	width[n] = 256;
	height[n] = 256;

	init_image(n, 0);
	add_sin_waves(n, 128.0, 128.0, 128.0, 0.0, 0.0, 0.0);

	//char file[256] = "";
	//load_image(0,file);
	//add_sin_waves(n, 0.0, 64.0, 0.0, 0.0, 32.0, 0.0);
}



void add_sin_waves(int n, double a0, double a, double Nx, double theta_x, double Ny, double theta_y) {
	int x, y, brightness;
	double term_x, term_y, value;

	for (y = 0; y < height[n]; y++) {
		for (x = 0; x < width[n]; x++) {
			if (Nx == 0)
				term_x = 0.0;
			else
				term_x = 2.0 * PI / Nx * (x - theta_x);

			if (Ny == 0)
				term_y = 0.0;
			else
				term_y = 2.0 * PI / Ny * (y - theta_y);
			value = a0 + a * sin(term_x + term_y);
			brightness = image[n][x][y] + value;
			if (brightness > 255)
				brightness = 255;
			else if(brightness < 0)
				brightness = 0;

			image[n][x][y] = brightness;

				
		}
	}

}