#include <stdio.h>
#include "pgmlib.h"
#include <math.h>

#define PI 3.14159265


void make_original_image(int n);
void add_sin_waves(int n, double a0, double a, double Nx, double theta_x, double Ny, double theta_y);


int main() {
	char file[256] = "";
	make_original_image(0);
	save_image(0, file);
	return 0;
}


void make_original_image(int n) {

	width[n] = 256;
	height[n] = 256;

	init_image(n, 0);
	add_sin_waves(n, 128.0, 128.0, 128.0, 0.0, 0.0, 0.0);


}

void add_sin_waves(int n, double a0, double a, double Nx, double theta_x, double Ny, double theta_y) {
	int x, y, brightness;
	double term_x, term_y, value;

	for (y = 0; y < height[n]; y++) {
		for (x = 0; x < width[n]; x++) {
			if (Nx == 0)
				term_x = 0.0;
			else
				term_x = 2.0 * PI / Nx * (x - theta_x);

			if (Ny == 0)
				term_y = 0.0;
			else
				term_y = 2.0 * PI / Ny * (y - theta_y);
			value = a0 + a * sin(term_x + term_y);
			brightness = image[n][x][y] + value;
			if (brightness > 255)
				brightness = 255;
			else if(brightness < 0)
				brightness = 0;

			image[n][x][y] = brightness;
				
		}
	}

}